//
// Animations for mandala (definitions)
//

// Constants

#define NB_GROUPES		72
#define NB_DRIVERS		3

#define QUANTUM_MIN		100
#define QUANTUM_MAX		10000
#define QUANTUM_PAS		100

// Structures 

typedef struct {
  int deltac,deltad,deltap;  	// Temps de croissance, de décroissance et de pause de luminosité
  unsigned int min,max;	// Valeurs maximale et minimale de la variation
  } variation_params;

typedef struct {
  long depart,arret;		// Départ et arrêt de l'animation basique
  int *groupes;			// Groupes de LEDs concernés par l'animation basique
  void *params;			// Paramètres de l'animation basique
				// Fonction réalisant l'animation basique
  void (*fun_anim)(int [],void *,long);
  } animation;

// Prototypes

void variation_groupes(int leds[],void *arg,long temps);
void variation_groupe(int leds[],void *arg,long temps);
void animation_play(animation *a);
void animation_all(void);
