#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "tlc5947.h"
#include "i2cmaster.h"
#include "zxgesture.h"
#include "animations.h"

#define	NB_DRIVERS	3
#define MAX_VALEUR	128
#define MAX_DISTANCE	20
#define WAIT_DELAY	1000

unsigned int groupes[NB_GROUPES];

int main(void)
{
i2c_init();
init_printf();

printf("Init. LED drivers\n");
init_LED_Drivers(NB_DRIVERS);

int model=zx_get_model();
printf("ZX gesture model=%d\n",model);

#ifndef SCANLEDS
while(1) animation_all();
#endif

#ifdef SCANLEDS
int n=0;
while(1){
  int i;
  printf("Channel #%d on\n",n);
  for(i=0;i<NB_DRIVERS*DLED_CHANNELS;i++) groupes[i]=(i==n)?MAX_VALEUR:0;
  set_LED_Drivers(groupes,NB_DRIVERS);
  n++; if(n>=NB_DRIVERS*DLED_CHANNELS) n=0;
  _delay_ms(WAIT_DELAY); 
  while(1)
    if(zx_position_ready()){
      int x,z;
      zx_get_positions(&x,&z);
      if(z<MAX_DISTANCE) break;
      }
  }
#endif

return 0;
}
