/** TLC5947 LEDs driver **/

// Include files

#include <avr/io.h>

#include "tlc5947.h"

// Global variables

// Functions

void init_LED_Drivers(int nb){
                        // LED drivers I/O as outputs
  DDR_DLED |= (1<<PIN_DLED_CLOCK) | (1<<PIN_DLED_DATA) | (1<<PIN_DLED_LATCH);
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
}


void set_LED_Drivers(unsigned int pwm[],int nb){
  int c,b;
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
  // 24 channels per TLC5947
  for(c=DLED_CHANNELS*nb-1;c>=0;c--){
    // 12 bits per channel, send MSB first
    int v=pwm[c];
    for(b=0;b<12;b++){
                        // Set CLOCK output low
      PORT_DLED &= ~(1<<PIN_DLED_CLOCK);

                        // Set DATA as stated by bit #b of c
      if(v & 0x0800)
        PORT_DLED |= (1<<PIN_DLED_DATA);
      else
        PORT_DLED &= ~(1<<PIN_DLED_DATA);

                        // Set CLOCK output HIGH
      PORT_DLED |= (1<<PIN_DLED_CLOCK);
      v <<= 1;
    }
  }
                        // Set CLOCK output low
  PORT_DLED &= ~(1<<PIN_DLED_CLOCK);

                        // Set LATCH output high
  PORT_DLED |= (1<<PIN_DLED_LATCH);
                        // Set LATCH output low
  PORT_DLED &= ~(1<<PIN_DLED_LATCH);
}
