//
// Gesture device library
//

// Include files

#include "i2cmaster.h"
#include "zxgesture.h"

// Functions 

/* Get ZX gesture register value */

int zx_getreg(int reg){
int ret;
i2c_start_wait(ZX_ADDR|I2C_WRITE);
i2c_write(reg);
i2c_rep_start(ZX_ADDR|I2C_READ);
ret=i2c_readNak();
i2c_stop();
return ret;
}

/* Get ZX gesture model number */

int zx_get_model(void){
int model=zx_getreg(ZX_REG_MODEL);
return model;
}

/* Is a position ready to be read ? */

unsigned char zx_position_ready(void){
int status=zx_getreg(ZX_REG_STATUS);
return (status&ZX_BIT_POSITION)?1:0;
}

/* Is a gesture ready to be read ? */

unsigned char zx_gesture_ready(void){
int status=zx_getreg(ZX_REG_STATUS);
return (status&ZX_BIT_GESTURE)?1:0;
}

/* Get X and Z positions */

void zx_get_positions(int *x,int *z){
*x=zx_getreg(ZX_REG_XPOS);
*z=zx_getreg(ZX_REG_ZPOS);
}

/* Get gesture */
int zx_get_gesture(void){
int gesture=zx_getreg(ZX_REG_GESTURE);
return gesture;
}
